/*  Drawing routine */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "global.h"


void redraw(Window window) {
  static GC  gc;
  Display    *dpy=XtDisplay(drawing_a);
  Dimension  width, height;
  int        i, j, k, dx, dy;
  int        y0, yunits;

  extern void showtime(int);
  extern void set_color(Widget, String, GC);
  if (!gc) {
    gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  }

  XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);

  yunits=0;
  for (i=0; i<8; i++) {
    if (ch[i].active) yunits+=ch[i].height+1;
    for (j=0; j<7; j++)
      if (dch[i].ch[j].active) yunits+=dch[i].ch[j].height+1;
  }
  y0=0;
  for (i=0; i<8; i++) {
    if (ch[i].active) {
      y0+=(height/yunits)*(ch[i].height+1);
      dx=ch[i].last-ch[i].xpos;
      if (dx<0) dx+=reg.xpix;
      if (dx>0) {
	if (!ch[i].addfirst) {
	  set_color(drawing_a, colors[ch[i].color], gc);
	  for (j=dx; j>0; j--)
	    XDrawLine(dpy, window, gc,
		      ch[i].last-j+LMAR+1,
		      y0-(height/yunits)*(ch[i].height+1)*(ch[i].min[ch[i].last-j])/4096,
		      ch[i].last-j+LMAR+1,
		      y0-(height/yunits)*(ch[i].height+1)*(ch[i].max[ch[i].last-j])/4096);
	  ch[i].xpos=ch[i].last;
	} // end addfirst;
	else {
	  set_color(drawing_a, "black", gc);
	  XDrawLine(dpy, window, gc,
		    reg.xpix-dx+LMAR, y0-(height/yunits)*(ch[i].height+1),
		    reg.xpix+LMAR, y0-(height/yunits)*(ch[i].height+1));
	  set_color(drawing_a, colors[ch[i].color], gc);
	  XCopyArea(dpy, window, window, gc,
		    dx+LMAR+1, y0-(height/yunits)*(ch[i].height+1),
		    reg.xpix-dx-1, (height/yunits)*(ch[i].height+1),
		    LMAR+1,  y0-(height/yunits)*(ch[i].height+1));
	  XClearArea(dpy, window, reg.xpix-dx+LMAR, y0-(height/yunits)*(ch[i].height+1)+1,
		     dx, (height/yunits)*(ch[i].height+1)-1, False);
	  for (j=0; j<dx; j++) {
	    dy=ch[i].last-dx+j;
	    if (dy<0) dy+=reg.xpix;
	    XDrawLine(dpy, window, gc,
		      reg.xpix-dx+j+LMAR, y0-(height/yunits)*(ch[i].height+1)*(ch[i].min[dy])/4096,
		      reg.xpix-dx+j+LMAR, y0-(height/yunits)*(ch[i].height+1)*(ch[i].max[dy])/4096);
	  }
	  ch[i].xpos=ch[i].last;
	} // end else addfirst;
      } // end if dx>0;
    } // end if active;
    for (j=0; j<7; j++) {
      if (dch[i].ch[j].active) {
	y0+=(height/yunits)*(dch[i].ch[j].height+1);
	dx=dch[i].ch[j].last-dch[i].ch[j].xpos;
	if (dx<0) dx+=reg.xpix;
	if (dx>0) {
	  if (!dch[i].ch[j].addfirst) {
	    set_color(drawing_a, colors[dch[i].ch[j].color], gc);
	    for (k=dx; k>0; k--)
	      XDrawLine(dpy, window, gc,
			dch[i].ch[j].last-k+LMAR+1,
			y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].min[dch[i].ch[j].last-k])/4096,
			dch[i].ch[j].last-k+LMAR+1,
			y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].max[dch[i].ch[j].last-k])/4096);
	    dch[i].ch[j].xpos=dch[i].ch[j].last;
	  } // end addfirst;
	  else {
	    set_color(drawing_a, "black", gc);
	    XDrawLine(dpy, window, gc,
		      reg.xpix-dx+LMAR, y0-(height/yunits)*(dch[i].ch[j].height+1),
		      reg.xpix+LMAR, y0-(height/yunits)*(dch[i].ch[j].height+1));
	    set_color(drawing_a, colors[dch[i].ch[j].color], gc);
	    XCopyArea(dpy, window, window, gc,
		      dx+LMAR+1, y0-(height/yunits)*(dch[i].ch[j].height+1),
		      reg.xpix-dx-1, (height/yunits)*(dch[i].ch[j].height+1),
		      LMAR+1,  y0-(height/yunits)*(dch[i].ch[j].height+1));
	    XClearArea(dpy, window, reg.xpix-dx+LMAR, y0-(height/yunits)*(dch[i].ch[j].height+1)+1,
		       dx, (height/yunits)*(dch[i].ch[j].height+1)-1, False);
	    for (k=0; k<dx; k++) {
	      dy=dch[i].ch[j].last-dx+k;
	      if (dy<0) dy+=reg.xpix;
	      XDrawLine(dpy, window, gc,
			reg.xpix-dx+k+LMAR, y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].min[dy])/4096,
			reg.xpix-dx+k+LMAR, y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].max[dy])/4096);
	    }
	    dch[i].ch[j].xpos=dch[i].ch[j].last;
	  } // end else addfirst;
	} // end if dx>0;
      } // end if active;
    } // end for j<7;
  } // end for i<8;
  if (reg.recon) showtime(1);
} // end function;

void clearscreen(Window window) {
  GC          gc;
  Display     *dpy=XtDisplay(drawing_a);
  XFontStruct *font;
  Dimension   width, height;
  int         i, j, k;
  float       scale_min, scale_max;
  float       ticmin, ticstep, ticmax;
  float       dy, yvalue, yf;
  double      wert;
  int         y0, yd, ntic, yunits, ypos;
  char        ylabel[20];

  extern int scale(float fmn, float fmx, int n, float *valmin, float *step, float *valmax);

  if (reg.nactive + der.nactive > 0) {
    gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
    font=XLoadQueryFont(dpy, "fixed");

    XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);
    XClearWindow(dpy,window);

    XDrawLine(dpy, window, gc, LMAR, 0, LMAR, height);
    yunits=0;
    for (i=0; i<8; i++) {
      if (ch[i].active) yunits+=ch[i].height+1;
      for (j=0; j<7; j++)
	if (dch[i].ch[j].active) yunits+=dch[i].ch[j].height+1;
    }
    y0=0; yd=height/yunits;
    for (i=0; i<8; i++) {
      if (ch[i].active) {
	y0+=(ch[i].height+1)*yd;
	ntic=(yd*(ch[i].height+1)/30)+1;
	XDrawLine(dpy, window, gc, 0, y0, width, y0);
	if (ntic>=2) {
	  scale_min=(ch[i].cal.rw_low * ch[i].cal.ad_high -
		     ch[i].cal.rw_high * ch[i].cal.ad_low) /
	            (ch[i].cal.ad_high - ch[i].cal.ad_low);
	  scale_max=(4095*(ch[i].cal.rw_high-ch[i].cal.rw_low) +
		     (ch[i].cal.rw_low*ch[i].cal.ad_high) -
		     (ch[i].cal.rw_high*ch[i].cal.ad_low))/
         	    (ch[i].cal.ad_high-ch[i].cal.ad_low);
	  scale(scale_min, scale_max, ntic, &ticmin, &ticstep, &ticmax);
	  yf=(float)yd*(ch[i].height+1)/(scale_max-scale_min);
	  for (j=-1; j<ntic+1; j++) {
	    ypos=(int)(y0-yf*(ticmin-scale_min)-yf*j*ticstep);
	    if ((ypos<y0-10) && (ypos>10+y0-yd*(ch[i].height+1))) {
	      XDrawLine(dpy, window, gc, LMAR-TICWIDTH, ypos, LMAR, ypos);
	      wert=ticmin+ticstep*j;
	      wert=floor(wert*10000.0+0.5)/10000.0;
	      sprintf(ylabel,"%6.4g", wert);
	      XDrawString(dpy, window, gc, 5, ypos+font->ascent/2,ylabel, 6);
	    }
	  }
	}
      }
      for (j=0; j<7; j++) {
	if (dch[i].ch[j].active) {
	  y0+=(dch[i].ch[j].height+1)*yd;
	  ntic=(yd*(dch[i].ch[j].height+1)/30)+1;
	  XDrawLine(dpy, window, gc, 0, y0, width, y0);
	  if (ntic>=2) {
	    scale_min=(dch[i].ch[j].cal.rw_low * dch[i].ch[j].cal.ad_high -
		       dch[i].ch[j].cal.rw_high * dch[i].ch[j].cal.ad_low) /
	      (dch[i].ch[j].cal.ad_high - dch[i].ch[j].cal.ad_low);
	    scale_max=(4095*(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low) +
		       (dch[i].ch[j].cal.rw_low*dch[i].ch[j].cal.ad_high) -
		       (dch[i].ch[j].cal.rw_high*dch[i].ch[j].cal.ad_low))/
	      (dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
	    scale(scale_min, scale_max, ntic, &ticmin, &ticstep, &ticmax);
	    yf=(float)yd*(dch[i].ch[j].height+1)/(scale_max-scale_min);
	    for (k=-1; k<ntic+1; k++) {
	      ypos=(int)(y0-yf*(ticmin-scale_min)-yf*k*ticstep);
	      if ((ypos<y0-10) && (ypos>10+y0-yd*(dch[i].ch[j].height+1))) {
		XDrawLine(dpy, window, gc, LMAR-TICWIDTH, ypos, LMAR, ypos);
		wert=ticmin+ticstep*k;
		wert=floor(wert*10000.0+0.5)/10000.0;
		sprintf(ylabel,"%6.4g", wert);
		XDrawString(dpy, window, gc, 5, ypos+font->ascent/2,ylabel, 6);
	      }
	    }
	  }
	}
      }
    }
    XFreeGC(dpy,gc);
    XFreeFont(dpy,font);
  }
}

void da_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  GC         gc;
  Window     window=XtWindow(drawing_a);
  Display    *dpy=XtDisplay(drawing_a);
  Dimension  width, height;
  int        x, xpos, i, j;
  int        y0,yunits;

  extern void set_color(Widget, String, GC);
  clearscreen(XtWindow(drawing_a));

  if (reg.recon && (reg.nactive+der.nactive>0)) {
    gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
    XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);
    yunits=0;
    for (i=0; i<8; i++) {
      if (ch[i].active) yunits+=ch[i].height+1;
      for (j=0; j<7; j++)
	if (dch[i].ch[j].active) yunits+=dch[i].ch[j].height+1;
    }
    y0=0;
    for (i=0; i<8; i++) {
      if (ch[i].active) {
	y0+=(height/yunits)*(ch[i].height+1);
	set_color(drawing_a, colors[ch[i].color], gc);
	x=ch[i].first; xpos=LMAR+1;
	while (x!=ch[i].last) {
	  XDrawLine(dpy, window, gc,
		    xpos, y0-(height/yunits)*(ch[i].height+1)*(ch[i].min[x])/4096,
		    xpos, y0-(height/yunits)*(ch[i].height+1)*(ch[i].max[x])/4096);
	  x++; xpos++;
	  if (x==reg.xpix) x=0;
	}
      }
      for (j=0; j<7; j++) {
	if (dch[i].ch[j].active) {
	  y0+=(height/yunits)*(dch[i].ch[j].height+1);
	  set_color(drawing_a, colors[dch[i].ch[j].color], gc);
	  x=dch[i].ch[j].first; xpos=LMAR+1;
	  while (x!=dch[i].ch[j].last) {
	    XDrawLine(dpy, window, gc,
		      xpos, y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].min[x])/4096,
		      xpos, y0-(height/yunits)*(dch[i].ch[j].height+1)*(dch[i].ch[j].max[x])/4096);
	    x++; xpos++;
	    if (x==reg.xpix) x=0;
	  }
	}
      }
    }
    XFreeGC(dpy,gc);
  }
}

void rs_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int i, j;
  char c[20];
  
  if (reg.recon) {
    reg.resize=1;
  }
  else {
    XtVaGetValues(drawing_a, XmNwidth, &reg.xpix, NULL);
    reg.xpix-=LMAR;
    reg.nbuf = reg.length*reg.sr/reg.xpix;
    if (reg.nbuf<1) {
      reg.nbuf=1;
      reg.length=reg.nbuf*reg.xpix/reg.sr;
    }
    sprintf(c,"%d", reg.length);
    XtVaSetValues(trace_label,
		  XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		  NULL);
    sprintf(c,"%d", reg.sr);
    XtVaSetValues(sr_label,
		  XtVaTypedArg, XmNlabelString, XmRString, c, strlen(c)+1,
		  NULL);
    for(i=0; i<8; i++) {
      ch[i].buf = (char *)realloc(ch[i].buf, reg.nbuf*2);
      ch[i].min = (int *)realloc(ch[i].min, reg.xpix*sizeof(int));
      ch[i].max = (int *)realloc(ch[i].max, reg.xpix*sizeof(int));
      for (j=0; j<7; j++) {
	dch[i].ch[j].min = (int *)realloc(dch[i].ch[j].min, reg.xpix*sizeof(int));
	dch[i].ch[j].max = (int *)realloc(dch[i].ch[j].max, reg.xpix*sizeof(int));
      }
    }
    if (XtWindow(drawing_a)) clearscreen(XtWindow(drawing_a));
  }
}
